#ifndef __HPCSS_WAVE_SELFDOC
#define __HPCSS_WAVE_SELFDOC

#include "par.h"

const char * sdoc[] = {
  "Rice HPCSS seismic modeling and migration package\n",
  "Note: units are meters, milliseconds. Thus frequencies are in KHz,",
  "and velocities can be interpreted as m/ms or km/s.\n",
  "Command line arguments - if default not given, then required.",
  "Description below: [value type] [keyword] [definition].",
  "Arguments should be entered on the command line as \"keyword=value\".\n",
  "1. All commands\n",
  "1.1 Spatial grid definition:",
  "  int nz           number of gridpoints in z ",
  "  int nx           number of gridpoints in x ",
  "  float dz         step in z ",
  "  float dx         step in x ",
  "1.2 Trace data attributes:",
  "  int nt           number of time steps ",
  "  float dt         step in t ",
  "  int igz          recvr depth, in units of dz [default=1]",
  "  int igxbeg       far left receiver x coord in units of dx [default=1]",
  "  int igxend       far right receiver x coord in units of dx [default=nx-1]",
  "1.3 Source attributes:",
  "  float freq       center frequency of Ricker wavelet ",
  "  int isz          source depth, in units of dz [default=1]",
  "  int isxbeg       far left source x coord in units of dx [default=nx/2]",
  "  int isxend       far right source x coord in units of dx [default=isxbeg]",
  "  int iskip        interval between sources in units of dx [default=1]",
  "1.4 Data files:",
  "  string velocity  velocity file - must contain >= nx*nz floats",
  "                   [if not provided, then velocity is set to",
  "                   internally defined constant - see wavefun.h.",
  "                   default=NULL (not given)]",
  "  string trace     trace output file ",
  "                   [if not provided, then no trace output (wave) or",
  "                   error condition (rtm, exrtm). default=NULL (not given)]",
  "  string source    movie file (source wavefield) ",
  "                   [if not provided, then no movie frames output (wave) or",
  "                   source wavefield computed by time reversal (rtm, exrtm).",
  "                   default=NULL (not given)]",
  "  int nm           number of time steps to skip between movie frames",
  "                   [<=0 for no movie; hardwired to 1 for rtm, exrtm if ",
  "                   mfile provided. default=0]",
  "\n2. RTM:\n"  
  "  string receiver  movie file (receiver wavefield) [default=NULL]",
  "  string image     image file [default=NULL]",
  "\n3. Extended RTM (prestack image volume):\n",
  "  int ihmax        offset radius, units of dx [default=0]",
  "  int imbeg        midpoint begin, units of dx [default=ihmax+1]",
  "  int imend        midpoint end, units of dx [default=nx-ihmax-1]",
  "  int imskip       midpoint skip units of dx [default=1]",
  NULL};
#endif
