#include "cstd.h"
#include "parser.h"

int main(int argc, char ** argv){
  FILE *fpv;
  int nz,nx;
  float dz,dx;
  int ix=0;
  int iz=0;
  float *v;
  char * vfile;

  PARARRAY par;

  if (ps_createargs(&par,argc,argv)) {
    fprintf(stderr,"ERROR: getinputs failed to process command line\n");
    return 1;
  }

  vfile=NULL;
  ps_ffcstring(par,"velocity",&vfile); 

  if (ps_ffint(par,"nz",&nz) ||
      ps_ffint(par,"nx",&nx) ||
      ps_ffreal(par,"dz",&dz)||
      ps_ffreal(par,"dx",&dx)) {
    fprintf(stderr,"ERROR: vam requires all four of nx, nz, dx, dz\n");
    fprintf(stderr,"ERROR: to be input on the command line\n");
    return 1;
  }
  v = (float*)malloc(nx*nz*sizeof(float));
  fpv = NULL;
  fpv = fopen(vfile,"w");
  for (ix=0;ix<nx;ix++){
     while(iz<nz/3){
       v[nz*ix+iz]=1.5;
       iz++;
     }
     while(iz<nz*2/3){
       v[nz*ix+iz]=1.6;
       iz++;
     }
     while(iz<nz){
       v[nz*ix+iz]=1.55;
       iz++;
     }
     iz=0;
   }
   fwrite(v,sizeof(float),nz*nx,fpv);
   free(v);
   fclose(fpv);
   
   if(vfile)
     printf("building velocity is done\n");

   exit(0);
}
