#ifndef __WAVE_STEP
#define __WAVE_STEP

/*
#define VERB 
*/

#include "cstd.h"

void step24_forward(float * restrict tgt_p, 
		    float * restrict src_p, 
		    float * restrict v,
		    int nz, int nx,
		    float rz, float rx, float s) {

  int iz;
  int ix;
  int ioff; 
  float two=2.0;
  float mot=-1.0/12.0;
  float fth=4.0/3.0;
  float mfh=-5.0/4.0;

  float motz=rz*mot;
  float motx=rx*mot;
  float fthz=rz*fth;
  float fthx=rx*fth;
  mfh=mfh*s;

  for (ix=2;ix<nx-2;ix++) {
    for (iz=2;iz<nz-2;iz++) {
      ioff=iz+ix*nz;
      tgt_p[ioff]=two*src_p[ioff]-tgt_p[ioff] +
	v[ioff]*(motz*(src_p[ioff+2]+   src_p[ioff-2]) +
		 motx*(src_p[ioff+2*nz]+src_p[ioff-2*nz]) +
		 fthz*(src_p[ioff+1]+   src_p[ioff-1]) +
		 fthx*(src_p[ioff+nz]+  src_p[ioff-nz]) +
		 mfh*src_p[ioff]);    
    }
  }
  
  for (ix=0;ix<nx;ix++) {
    tgt_p[ix*nz]=-tgt_p[ix*nz+2];
    tgt_p[ix*nz+nz-1]=-tgt_p[ix*nz+nz-3];
  }
  for (iz=0;iz<nz;iz++) {
    tgt_p[iz]=-tgt_p[iz+2*nz];
    tgt_p[iz+(nx-1)*nz]=-tgt_p[iz+(nx-3)*nz];
  }
  
}

#endif
